<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>bitten.report.coverage.TestCoverageAnnotator</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="bitten-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="../index.html">Documentation Index</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="bitten-module.html">Package&nbsp;bitten</a> ::
        <a href="bitten.report-module.html">Package&nbsp;report</a> ::
        <a href="bitten.report.coverage-module.html">Module&nbsp;coverage</a> ::
        Class&nbsp;TestCoverageAnnotator
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class TestCoverageAnnotator</h1><p class="nomargin-top"></p>
<pre class="base-tree">
         object --+    
                  |    
trac.core.Component --+
                      |
                     <strong class="uidshort">TestCoverageAnnotator</strong>
</pre>

<hr />
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> genshi.builder <span class="py-keyword">import</span> tag
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> trac.test <span class="py-keyword">import</span> Mock, MockPerm
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> trac.mimeview <span class="py-keyword">import</span> Context
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> trac.util.datefmt <span class="py-keyword">import</span> to_datetime, utc
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> trac.web.href <span class="py-keyword">import</span> Href
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> bitten.model <span class="py-keyword">import</span> BuildConfig, Build, Report
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">from</span> bitten.report.tests.coverage <span class="py-keyword">import</span> env_stub_with_tables
<span class="py-prompt">&gt;&gt;&gt; </span>env = env_stub_with_tables()
<span class="py-prompt">&gt;&gt;&gt; </span>repos = Mock(get_changeset=<span class="py-keyword">lambda</span> x: Mock(date=to_datetime(12345, utc)))
<span class="py-prompt">&gt;&gt;&gt; </span>env.get_repository = <span class="py-keyword">lambda</span>: repos</pre>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>BuildConfig(env, name=<span class="py-string">'trunk'</span>, path=<span class="py-string">'trunk'</span>).insert()
<span class="py-prompt">&gt;&gt;&gt; </span>Build(env, rev=123, config=<span class="py-string">'trunk'</span>, rev_time=12345, platform=1).insert()
<span class="py-prompt">&gt;&gt;&gt; </span>rpt = Report(env, build=1, step=<span class="py-string">'test'</span>, category=<span class="py-string">'coverage'</span>)
<span class="py-prompt">&gt;&gt;&gt; </span>rpt.items.append({<span class="py-string">'file'</span>: <span class="py-string">'foo.py'</span>, <span class="py-string">'line_hits'</span>: <span class="py-string">'5 - 0'</span>})
<span class="py-prompt">&gt;&gt;&gt; </span>rpt.insert()</pre>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>ann = TestCoverageAnnotator(env)
<span class="py-prompt">&gt;&gt;&gt; </span>req = Mock(href=Href(<span class="py-string">'/'</span>), perm=MockPerm(),
<span class="py-more">... </span>                chrome={<span class="py-string">'warnings'</span>: []}, args={})</pre>
<p>Version in the branch should not match:
&gt;&gt;&gt; context = Context.from_request(req, 'source', '/branches/blah/foo.py', 123)
&gt;&gt;&gt; ann.get_annotation_data(context)
[]</p>
<p>Version in the trunk should match:
&gt;&gt;&gt; context = Context.from_request(req, 'source', '/trunk/foo.py', 123)
&gt;&gt;&gt; data = ann.get_annotation_data(context)
&gt;&gt;&gt; print data
[u'5', u'-', u'0']</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">def</span> <span class="py-defname">annotate_row</span>(lineno, line):
<span class="py-more">... </span>    row = tag.tr()
<span class="py-more">... </span>    ann.annotate_row(context, row, lineno, line, data)
<span class="py-more">... </span>    return row.generate().render(<span class="py-string">'html'</span>)</pre>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>annotate_row(1, <span class="py-string">'x = 1'</span>)
<span class="py-output">'&lt;tr&gt;&lt;th class=&quot;covered&quot;&gt;5&lt;/th&gt;&lt;/tr&gt;'</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span>annotate_row(2, <span class="py-string">''</span>)
<span class="py-output">'&lt;tr&gt;&lt;th&gt;&lt;/th&gt;&lt;/tr&gt;'</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span>annotate_row(3, <span class="py-string">'y = x'</span>)
<span class="py-output">'&lt;tr&gt;&lt;th class=&quot;uncovered&quot;&gt;0&lt;/th&gt;&lt;/tr&gt;'</span></pre>

<!-- ==================== NESTED CLASSES ==================== -->
<a name="section-NestedClasses"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Nested Classes</span></td>
</tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code>trac.core.Component</code></b>:
      <code><a href="trac.core.ComponentMeta-class.html">__metaclass__</a></code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Instance Methods</span></td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="pre_process_request"></a><span class="summary-sig-name">pre_process_request</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">req</span>,
        <span class="summary-sig-arg">handler</span>)</span></td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="post_process_request"></a><span class="summary-sig-name">post_process_request</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">req</span>,
        <span class="summary-sig-arg">template</span>,
        <span class="summary-sig-arg">data</span>,
        <span class="summary-sig-arg">content_type</span>)</span><br />
      Adds a 'Coverage' context navigation menu item.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="get_annotation_type"></a><span class="summary-sig-name">get_annotation_type</span>(<span class="summary-sig-arg">self</span>)</span></td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="get_annotation_data"></a><span class="summary-sig-name">get_annotation_data</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">context</span>)</span></td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="annotate_row"></a><span class="summary-sig-name">annotate_row</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">context</span>,
        <span class="summary-sig-arg">row</span>,
        <span class="summary-sig-arg">lineno</span>,
        <span class="summary-sig-arg">line</span>,
        <span class="summary-sig-arg">data</span>)</span></td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="bitten.report.coverage.TestCoverageAnnotator-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">compmgr</span>,
        <span class="summary-sig-arg">init</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">cls</span>=<span class="summary-sig-default">&lt;class 'bitten.report.coverage.TestCoverageAnnotator'&gt;</span>)</span><br />
      x.__init__(...) initializes x; see x.__class__.__doc__ for signature</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code>object</code></b>:
      <code>__delattr__</code>,
      <code>__format__</code>,
      <code>__getattribute__</code>,
      <code>__hash__</code>,
      <code>__reduce__</code>,
      <code>__reduce_ex__</code>,
      <code>__repr__</code>,
      <code>__setattr__</code>,
      <code>__sizeof__</code>,
      <code>__str__</code>,
      <code>__subclasshook__</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== STATIC METHODS ==================== -->
<a name="section-StaticMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Static Methods</span></td>
</tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code>trac.core.Component</code></b>:
      <code>__new__</code>,
      <code>implements</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== PROPERTIES ==================== -->
<a name="section-Properties"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Properties</span></td>
</tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code>object</code></b>:
      <code>__class__</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Method Details</span></td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">compmgr</span>,
        <span class="sig-arg">init</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">cls</span>=<span class="sig-default">&lt;class 'bitten.report.coverage.TestCoverageAnnotator'&gt;</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    >&nbsp;
    </td>
  </tr></table>
  
  x.__init__(...) initializes x; see x.__class__.__doc__ for signature
  <dl class="fields">
    <dt>Overrides:
        object.__init__
        <dd><em class="note">(inherited documentation)</em></dd>
    </dt>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="bitten-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="../index.html">Documentation Index</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Fri Mar 11 14:53:36 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
